package test;

import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.Path;
import java.util.UUID;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;

import com.objectdb.jpa.Provider;

import test.entity.MyEntity;
import test.type.implementation.MyType;

public class MyTestCase {

	public static void main(String[] args) throws IOException {
		try {
			Path file = Files.createTempFile(UUID.randomUUID().toString(), ".objectdb");
			
			System.out.println(file.toString());
			
			EntityManagerFactory entityManagerFactory = new Provider().createEntityManagerFactory(file.toString(), null);
			
			EntityManager entityManager = entityManagerFactory.createEntityManager();
			
			// Create entity
			
			MyEntity entity = new MyEntity();
			
			// Persist entity
			
			entityManager.getTransaction().begin();
			entityManager.persist(entity);
			entityManager.getTransaction().commit();
			
			// Get entity
			
			entity = entityManager.createQuery("SELECT e FROM MyEntity e", MyEntity.class).getSingleResult();
			
			// Add type	
			
			entity.getTypes().add(MyType.A);
			
			// Merge entity
			
			entityManager.getTransaction().begin();
			entityManager.merge(entity);
			entityManager.getTransaction().commit();
			
			// Get entity
			
			entity = entityManager.createQuery("SELECT e FROM MyEntity e", MyEntity.class).getSingleResult();
			
			// Test type
			
			System.out.println((entity.getTypes().iterator().next().equals(MyType.A)) ? "PASSED" : "FAILED");
		} catch(Exception e) {
			e.printStackTrace();
		}
	}
	
}
